3374f1b3bf564ab0b68a50686d5f9b624d7af1d8
[oweals/gnunet.git] / src / gns / test_gns_delegated_lookup.sh
1 #!/bin/bash
2 trap "gnunet-arm -e -c test_gns_lookup.conf" SIGINT
3 which timeout &> /dev/null && DO_TIMEOUT="timeout 30"
4
5 LOCATION=$(which gnunet-config)
6 if [ -z $LOCATION ]
7 then
8   LOCATION="gnunet-config"
9 fi
10 $LOCATION --version 1> /dev/null
11 if test $? != 0
12 then
13         echo "GNUnet command line tools cannot be found, check environmental variables PATH and GNUNET_PREFIX"
14         exit 77
15 fi
16
17 rm -rf `gnunet-config -c test_gns_lookup.conf -f -s paths -o GNUNET_TEST_HOME`
18 MY_EGO="myego"
19 OTHER_EGO="delegatedego"
20 FINAL_LABEL="www"
21 DELEGATION_LABEL="b"
22
23 TEST_IP="127.0.0.1"
24 gnunet-arm -s -c test_gns_lookup.conf
25 gnunet-identity -C $OTHER_EGO -c test_gns_lookup.conf
26 DELEGATED_PKEY=$(gnunet-identity -d -c test_gns_lookup.conf | grep $OTHER_EGO | awk '{print $3}')
27 gnunet-identity -C $MY_EGO -c test_gns_lookup.conf
28 gnunet-namestore -p -z $MY_EGO -a -n $DELEGATION_LABEL -t PKEY -V $DELEGATED_PKEY -e never -c test_gns_lookup.conf
29 gnunet-namestore -p -z $OTHER_EGO -a -n $FINAL_LABEL -t A -V $TEST_IP -e never -c test_gns_lookup.conf
30 RES_IP=`$DO_TIMEOUT gnunet-gns --raw -u $FINAL_LABEL.$DELEGATION_LABEL.$MY_EGO -t A -c test_gns_lookup.conf`
31 gnunet-namestore -z $MY_EGO -d -n b -t PKEY -V $DELEGATED_PKEY  -e never -c test_gns_lookup.conf
32 gnunet-namestore -z $OTHER_EGO -d -n $FINAL_LABEL -t A -V $TEST_IP  -e never -c test_gns_lookup.conf
33 gnunet-arm -e -c test_gns_lookup.conf
34
35 rm -rf `gnunet-config -c test_gns_lookup.conf -f -s paths -o GNUNET_TEST_HOME`
36
37 if [ "$RES_IP" == "$TEST_IP" ]
38 then
39   exit 0
40 else
41   echo "Failed to resolve to proper IP, got $RES_IP."
42   exit 1
43 fi